/* LISTS in Prolog       */
/* Radim Belohlavek */

/* member(X,Y) ... X je prvkem seznamu Y*/
memberL(X,[X|T]).
memberL(X,[Y|T]) :- memberL(X,T).


/* firstEl(X,Y) ... X je prvnim prvkem seznamu Y */
firstEl(X,[X|_]):-!.  /* rez ! je tam, aby se zabranilo moznosti zpetneho navraceni; 
co by se stalo, kdyby tam rez nebyl? */

/* UKOL: navrhnete predikat secondEl tak, ze secondEl(X,Y) prave kdyz X je druhym prvkem seznamu Y */
/*reseni 1*/
secondEl(X,[_,X|_]):-!.


/* UKOL: navrhnete predikat thirdEl tak, ze thirdEl(X,Y) prave kdyz X je tretim prvkem seznamu Y */

/* UKOL: navrhnete predikat nthEl tak, ze nthEl(X,N,Y) prave kdyz X je N-tym prvkem seznamu Y */

nthEl(X,1,[X|T]).
nthEl(X,N,[Y|T]):- nthEl(X,N1,T), N is N1+1.

/*
proc je nasledujici spatne?
nthEl(X,1,[X|T]).
nthEl(X,N,[Y|T]):- N is N1+1, nthEl(X,N1,T).
*/


/* UKOL: navrhnete predikat lastEl tak, ze lastEl(X,Y) prave kdyz X je poslednim prvkem seznamu Y*/
/*reseni */
lastEl(X,[X]).
lastEl(X,[_|Y]):-lastEl(X,Y).

/* UKOL: navrhnete predikat lastButOneEl tak, ze lastButOneEl(X,Y) prave kdyz X je predposlednim prvkem seznamu Y*/
/*reseni */
lastButOneEl(X,[X,Y]).
lastButOneEl(X,[_|Y]):-lastButOneEl(X,Y).

/* lengthL(X,N) ... N is the length of the list X*/
lengthL([],0).
lengthL([_|T],N):-lengthL(T,N1), N is N1+1.

/* UKOL: navrhnete predikat occurrence, aby occurrence(X,Y,N) pravek kdyz X se v seznamu Y vyskytuje prave N-krat  */
/* reseni */

occurrence(X,[],0).
occurrence(X,[X|T],N):-occurrence(X,T,N1), N is N1+1.
occurrence(X,[Y|T],N):-Y\==X, occurrence(X,T,N).   /*zde Y\==X ... term Y se nerovna termu X */



/* deleteFromList(X,Y,Z) ... Z vznikne odstranenim vsech vyskytu X ze seznamu Y */
deleteFromList(X,[],[]).
deleteFromList(X,[X|T],S):-!,deleteFromList(X,T,S).
deleteFromList(X,[Y|T1],[Y|T2]):-deleteFromList(X,T1,T2).

/* UKOL: deleteFirst(X,Y,Z) ... Z vznikne vymazanim prvniho vyskytu X z Y */

/* UKOL: deleteFirstN(X,N,Y,Z) ... Z vznikne vymazanim prvnich N vyskytu X z Y; je-li tam tech vyskytu
    M<N, pak vymazanim prvnich M vyskytu*/
deleteFirstAtMostN(X,0,Y,Y):-!. /*rez, aby pri zpetnem navraceni nedoslo k pokusu o unifikaci s 3. a 4. vyskytem 
                                 deleteFirstAtMostN*/
deleteFirstAtMostN(X,N,[],[]).
deleteFirstAtMostN(X,N,[X|T],S):-!, N1 is N-1, deleteFirstAtMostN(X,N1,T,S).
deleteFirstAtMostN(X,N,[Y|T],[Y|S]):-deleteFirstAtMostN(X,N,T,S).


/* UKOL: deleteFirstN(X,N,Y,Z) ... Z vznikne vymazanim prvnich prave N vyskytu X z Y*/


/*appendL(X,Y,Z) ... Z is X followed by Y */
appendL([],T,T).
appendL([X|T],K,[X|U]) :- appendL(T,K,U).


/* insertFirst(X,Y,Z) ... Z vznikne vlozenim X pred prvni prvek seznamu Y*/
insertFirst(X,Y,[X|Y]).

/* insertLast(X,Y,Z) ... Z vznikne vlozenim X za posledni prvek seznamu Y*/
insertLast(X,[],[X]).
insertLast(X,[Y|T1],[Y|T2]):-insertLast(X,T1,T2).


/* UKOL: insertN(X,N,Y,Z) ... Z vznikne vlozenim X za N-ty prvek do seznamu Y */

/* insertNt(X,N,Y1,Y2,Z) ... Z je spojenim Y1 a seznamu vznikleho vlozenim X za N-ty prvek Y2 */

insertNt(X,0,Y1,Y2,Z):-append(Y1,[X|Y2],Z).
insertNt(X,N,Y1,[Y|T],Z):- N1 is N-1, insertLast(Y,Y1,Y2), insertNt(X,N1,Y2,T,Z).

insertN(X,N,Y,Z):-insertNt(X,N,[],Y,Z).


/* UKOL: insertAfterFirst(X,Y,U,V)  ... V vznikne vlozenim X za prvni vyskyt prvku Y v seznamu U*/

/* UKOL: insertAfterLast(X,Y,U,V)  ... V vznikne vlozenim X za posledni vyskyt prvku Y v seznamu U*/

/* UKOL: insertAfterAll(X,Y,U,V)  ... V vznikne vlozenim X za kazdy vyskyt prvku Y v seznamu U*/


/* UKOL: insertAfterN(X,Y,U,V,N)  ... V vznikne vlozenim X za N-ty vyskyt prvku Y v seznamu U*/


/*replaceFirst(X,Y,U,V) ... V vznikne z U nahrazenim prvniho vyskytu prvku Y prvkem X */
replaceFirst(X,Y,[],[]).
replaceFirst(X,Y,[Y|T],[X|T]):-!.
replaceFirst(X,Y,[Z|T1],[Z|T2]):-replaceFirst(X,Y,T1,T2).

/* UKOL: */
/* replaceLast(X,Y,U,V) ... V vznikne z U nahrazenim posledniho vyskytu prvku Y prvkem X */

/* UKOL: */
/* replaceAll(X,Y,U,V) ... V vznikne z U nahrazenim kazdeho vyskytu prvku Y prvkem X */

/* UKOL: */
/* replaceN(X,Y,U,V,N) ... V vznikne z U nahrazenim N-teho vyskytu prvku Y prvkem X */


/* UKOL: doubleFirst(X,U,V) ... V vznikne zdvojenim prvniho vyskytu prvku X v seznamu U, napr. 
                                double(a,[b,a,c,a,d],[b,a,a,c,a,d])*/

doubleFirst(X,[],[]).
doubleFirst(X,[X|T],[X,X|T]):-!.
doubleFirst(X,[Z|T1],[Z|T2]):-doubleFirst(X,T1,T2).

/* UKOL: doubleLast(X,U,V) ... V vznikne zdvojenim posledniho vyskytu prvku X v seznamu U */

/* UKOL: doubleAll(X,U,V) ... V vznikne zdvojenim kazdeho vyskytu prvku X v seznamu U */

/* UKOL: doubleN(X,U,V,N) ... V vznikne zdvojenim N-teho vyskytu prvku X v seznamu U */


/* UKOL: multiplyFirst(X,M,U,V) ... V vznikne M-nasobnym zmnozenim prvniho vyskytu prvku X v U, napr.
                                    multiply(a,3,[b,a,g,a,a,f],[b,a,a,a,g,a,a,f]) */

/* UKOL: multiplyLast(X,M,U,V) ... V vznikne M-nasobnym zmnozenim posledniho vyskytu prvku X v U */

/* UKOL: multiplyAll(X,M,U,V) ... V vznikne M-nasobnym zmnozenim kazdeho vyskytu prvku X v U */

/* UKOL: multiplyN(X,M,U,V,N) ... V vznikne M-nasobnym zmnozenim N-teho vyskytu prvku X v U */



/* reverseL(X,Y) ... seznam X je obracenim seznamu Y */
reverseL([],[]).
reverseL([X|T],U) :- reverseL(T,L), appendL(L,[X],U).

/*followsL(X,Y,Z) ... Y nasleduje za X v seznamu Z*/
followsL(X,Y,[X,Y|T]).
followsL(X,Y,[Z|T]) :- followsL(X,Y,T).


/*listL(X) ... X je seznam */
listL([]).
listL([X|T]) :- listL(T).

/*argument is a list; listLL(X) leads to infinite loop*/
listLL([X|T]) :- listLL(T).
listLL([]).

/* append3(X,Y,Z,U) ... U is the result of  appendding W to X where W is the result of appending Z to Y */
append3(X,Y,Z,U):-appendL(X,A,U), appendL(Y,Z,A).

/* prefix(X,Y) ... X je prefixem (tj. pocatecnim usekem)  Y */
prefix([],_).
prefix([X|T1],[X|T2]):-prefix(T1,T2).

/* partOf(X,Y) ... X je casti (tj. souvislym podusekem) seznamu Y */
partOf([],_).
partOf([X|T1],[X|T2]):-prefix(T1,T2),!.
partOf(X,[_|T]):-partOf(X,T).

/* subset(X,Y) ... kazdy prvek seznamu X je prvkem seznamu Y */
subsetL([X|T],U):-memberL(X,U), subsetL(T,U).
subsetL([],_).

/* sublist(X,Y) ... X je podseznamem Y, tj. Y vznikne vlozenim nejakych prvku do X */
sublist([X|T1],[X|T2]):-sublist(T1,T2).
sublist(U,[_|T]):-sublist(U,T).
sublist([],_).

/* listsToNumbers(X,Y) ... X is a list of lists and Y is a list of numbers of elements of these lists, e.g.
                              listsToNumbers([[a],[],[c,f,[a,s,d]]],[1,0,3])*/
listsToNumbers([],[]).
listsToNumbers([X|T1],[N|T2]):-length(X,N), listsToNumbers(T1,T2).

/* listToSet(X,Y) ... Y obsahuje tytez prvky jako X, ale kazdy prvek se v Y vyskytuje prave 1x */
listToSet([],[]).
listToSet(U,[X|V]):-member(X,U), deleteFromList(X,U,U1), listToSet(U1,V),!.

/* listToMultiset(X,Y) ... Y obsahuje dvojice [a,n], kde a je prvek seznamu X, n je pocet jeho vyskytu v X;
                           pro kazdy a z X je v Y prave jedna dvojice [a,n]; dvojice [a,0] se neuvadeji */


/* UKOL:
 listsToSets(X,Y)  ... X je seznam seznamu, Y je seznam seznamu, ktery vznikne z X tak, ze kazdy seznam-prvek U seznamu
                         X  je nahrazen seznamem V, ktery ma stejne prvky jako U, ale kazdy prvek se ve V vyskytuje 
                        jen 1x, napr. listsToSets([[a,a,a,a],[a,b,c],[a,b,c,a,d,c,c]],[[a],[a,b,c],[a,b,c,d]])*/

/* longestList(X,N) ... X je seznam seznamu, N je delka nejdelsiho z nich */
maxL(X,Y,Y):-X=<Y.
maxL(X,Y,X):-X>=Y.

longestList([],0).
longestList([X|U],N):-lengthL(X,N1), longestList(U,N2), maxL(N1,N2,N).


/* UKOLY */

/* writeN(X,N) vypise vsechny prvky seznamu X, ktere maji v X aspon N vyskytu; kazdy takovy prvek se vypise jen 1x */


/*unionOfLists(U,V,W) ... W je seznam prvku, ktere jsou v seznamu U nebo V; kazdy prvek je v W prave 1x */

/*intersectionOfLists(U,V,W) ... W je seznam prvku, ktere jsou v seznamu U i V; kazdy prvek je v W prave 1x */



